unit xpcx;
interface Procedure LoadPCX (F: String; S: Word);
	  Procedure LoadPCX2(F: String; S: Word);
          PROCEDURE MW (addr:longint;byt:byte);
          PROCEDURE MWW(addr:longint;wOR:wORd);
          PROCEDURE MWD(addr:longint;dwOR:longint);
          FUNCTION  MR (addr:longint):byte;
          FUNCTION  MRW(addr:longint):wORd;
          FUNCTION  MRD(addr:longint):wORd;
          PROCEDURE xLoadPCX(F:String;S:LongInt;XS:Longint;pf:byte);
          PROCEDURE XMS(addr1,addr2,Count:longint);
          PROCEDURE MFD(addr,count,fill:longint);
implementation
(*MEMORY MOVE DWORD*)
PROCEDURE XMS(addr1,addr2,count:longint);BEGIN;ASM push es;db 66h
mov si,word ptr addr1;db 66h;mov di,word ptr addr2;db 66h
mov cx,word ptr count;db 66h;shr cx,2;push ds;xor ax,ax;mov es,ax;mov ds,ax
rep;dw 6667h;movsw;pop ds;pop es end;end;

(*MEMORY FILL DWORD*)
PROCEDURE MFD(addr,count,fill:longint);BEGIN;ASM push es;xor ax,ax;mov es,ax
db 66h;mov di,word ptr addr;db 66h;mov ax,word ptr fill;db 66h
mov cx,word ptr count;db 66h;shr cx,2;db 0f3h,066h,067h,0abh;pop es end;end;


{PROCEDURE XMS(Addr1,Addr2,Anzahl:longint);begin;asm
push ds;db 66h,60h;xor ax,ax;mov ds,ax
db 66h;mov si,word ptr Addr1
db 66h;mov di,word ptr Addr2
db 66h;mov cx,word ptr Anzahl
db 66h;shr cx,2;@:
db 67h,66h,8bh,6
db 67h,66h,89h,7
db 66h,83h,0c6h,4
db 66h,83h,0c7h,4
loop @;db 66h,61h;pop ds;end;end;}

PROCEDURE xLoadPCX(F:String;S:LongInt;XS:Longint;pf:byte);
{Name,Addr,XS,Pallette Load?}
VAR Q:FILE;
    B:ARRAY[0..2047]OF byte;
    Anz,Pos,W,H,E,Pack,D,X,C:wORd;
    I:Byte;
    Adr,Y:LongInt;
BEGIN
  X:=0;
  Y:=0;
  Assign(Q,F);
  Reset(Q,1);
  {------PALETTE LOAD ?------}
IF pf=1 THEN BEGIN
  Seek(Q,FILESize(Q)-3*256-1);
  BlockRead(Q,B,3*256+1);
  IF B[0]=12 THEN BEGIN
     FOR I:=0 TO 255 DO BEGIN
	 PORt[$3C8]:=I;
	 PORt[$3C9]:=B[I*3+1]SHR 2;
	 PORt[$3C9]:=B[I*3+2]SHR 2;
	 PORt[$3C9]:=B[I*3+3]SHR 2;
     END;
  END;
END;
  {------PICTURE LOAD--------}
  Seek (Q,0);
  BlockRead (Q,B,128,Anz);
  IF (B[0]<>10) OR (B[3]<>8) THEN BEGIN
     close (Q);
     exit;
  END;
  W:=(B[9] -B[5])*256+B[8] -B[4]+1;
  H:=(B[11]-B[7])*256+B[10]-B[6]+1;
  Pack:=0;
  C:=0;
  E:=Y+H;

  REPEAT
    BlockRead(Q,B,2048,Anz);
    Pos:=0;
    while (Pos<Anz) AND (Y<E) DO BEGIN
          IF Pack <> 0 THEN BEGIN
             Adr:=X+C+Y* XS;
	     FOR D:=0 TO Pack DO BEGIN
                 MW(S+Adr,B[Pos]);
		 Inc(Adr);
	     END;
	     Inc(C,Pack);
	     Pack := 0;
	  END else IF (B[Pos] AND $C0)=$C0 THEN Pack:=B[Pos] AND $3F else BEGIN
	      Adr:=X+C+Y* XS;
	      MW(S+Adr,B[Pos]);
	      Inc(C)
	  END;
	  Inc(Pos);
          IF C=W THEN BEGIN
	     C:=0;
	     Inc(Y);
	  END;
    END;
  UNTIL(Anz=0) OR (Y=E);
  close (Q);
END;
(*MEMORY WRITE BYTE*)
PROCEDURE MW (addr:longint;byt:byte);ASSEMBLER;ASM push es;xOR ax,ax
mov es,ax;mov al,byt;db 66h;mov di,wORd ptr addr;dd 7882667h;pop es;END;

(*MEMORY WRITE WORD*)
PROCEDURE MWW(addr:longint;wOR:wORd);ASSEMBLER;ASM push es;xOR ax,ax
mov es,ax;mov ax,wOR;db 66h;mov di,wORd ptr addr;dd 7892667h;pop es;END;

(*MEMORY WRITE DWORD*)
PROCEDURE MWD(addr:longint;dwOR:longint);ASSEMBLER;ASM push es;xOR ax,ax
mov es,ax;db 66h;mov ax,wORd ptr dwOR;db 66h;mov di,wORd ptr addr;
db 67h,66h,26h,89h,7;pop es;END;

(*MEMORY READ BYTE*)
FUNCTION  MR (addr:longint):byte;VAR au:byte;BEGIN;ASM push es;xOR ax,ax
mov es,ax;db 66h;mov di,wORd ptr addr;dd 78A2667h;mov au,al;pop es;END;mr:=au;END;

(*MEMORY READ WORD*)
FUNCTION  MRW(addr:longint):wORd;VAR au:wORd;BEGIN;ASM push es;xOR ax,ax
mov es,ax;db 66h;mov di,wORd ptr addr;dd 78B2667h;mov au,ax;pop es;END;mrw:=au;END;

(*MEMORY READ DWORD*)
FUNCTION  MRD(addr:longint):wORd;VAR au:lOngiNt;BEGIN;ASM push es;xOR ax,ax
mov es,ax;db 66h;mov si,wORd ptr addr;dw 6667h;lodsw;
db 66h;mov word ptr au,ax;pop es;END;mrd:=au;END;

Procedure LoadPCX (F: String; S: Word);
Var
  Q: File;
  B: Array[0..2047] Of Byte;
  Anz,Pos,C,W,H,E,Pack: Word;
  I    : Byte;
  D,X,Y: Word;
  Adr  : Word;
Begin
  X:=0;Y:=0;
  Assign (Q,F);
  Reset (Q,1);
  BlockRead (Q,B,128,Anz);
  If (B[0] <> 10) Or (B[3] <> 8) Then Begin
    Close (Q);
    Exit;
  End;
  W := Succ((B[9]-B[5])*256+B[8]-B[4]);
  H := Succ((B[11]-B[7])*256+B[10]-B[6]);
  Pack := 0;
  C := 0;
  E := Y+H;
  Repeat
    BlockRead(Q,B,2048,Anz);
    Pos := 0;
    While (Pos < Anz) And (Y < E) Do begin
      If Pack <> 0 Then Begin
	Adr := X+C+Y*320;
	For D := 0 to Pack Do Begin
	  Mem[S:Adr] := B[Pos];
	  Inc (Adr);
	End;
	Inc (C,Pack);
	Pack := 0;
      End
      Else If (B[Pos] AND $C0) = $C0 Then Pack := B[Pos] AND $3F
      Else Begin
	Adr := X+C+Y*320;
	Mem[S:Adr] := B[Pos];
	Inc (C)
      End;
      Inc (Pos);
      If C = W Then Begin
	C := 0;
	Inc (Y);
      End;
    End;
  Until (Anz = 0) Or (Y = E);
  Seek (Q,FileSize(Q)-3*256-1);
  BlockRead(Q,B,3*256+1);
  If B[0] = 12 then begin
    For I := 0 To 255 Do Begin
      Port[$3C8] := I;
      Port[$3C9] := B[I*3+1] SHR 2;
      Port[$3C9] := B[I*3+2] SHR 2;
      Port[$3C9] := B[I*3+3] SHR 2;
    End;
  End;
  Close (Q);
End;

Procedure LoadPCX2(F: String; S: Word);
Var
  Q: File;
  B: Array[0..2047] Of Byte;
  Anz,Pos,C,W,H,E,Pack: Word;
  I    : Byte;
  D,X,Y: Word;
  Adr  : Word;
Begin
  X:=0;Y:=0;
  Assign (Q,F);
  Reset (Q,1);
  BlockRead (Q,B,128,Anz);
  If (B[0] <> 10) Or (B[3] <> 8) Then Begin
    Close (Q);
    Exit;
  End;
  W := Succ((B[9]-B[5])*256+B[8]-B[4]);
  H := Succ((B[11]-B[7])*256+B[10]-B[6]);
  Pack := 0;
  C := 0;
  E := Y+H;
  Repeat
    BlockRead(Q,B,2048,Anz);
    Pos := 0;
    While (Pos < Anz) And (Y < E) Do begin
      If Pack <> 0 Then Begin
	Adr := X+C+Y*256;
	For D := 0 to Pack Do Begin
	  Mem[S:Adr] := B[Pos];
	  Inc (Adr);
	End;
	Inc (C,Pack);
	Pack := 0;
      End
      Else If (B[Pos] AND $C0) = $C0 Then Pack := B[Pos] AND $3F
      Else Begin
	Adr := X+C+Y*256;
	Mem[S:Adr] := B[Pos];
	Inc (C)
      End;
      Inc (Pos);
      If C = W Then Begin
	C := 0;
	Inc (Y);
      End;
    End;
  Until (Anz = 0) Or (Y = E);
  Seek (Q,FileSize(Q)-3*256-1);
  BlockRead(Q,B,3*256+1);
  If B[0] = 12 then begin
    For I := 0 To 255 Do Begin
      Port[$3C8] := I;
      Port[$3C9] := B[I*3+1] SHR 2;
      Port[$3C9] := B[I*3+2] SHR 2;
      Port[$3C9] := B[I*3+3] SHR 2;
    End;
  End;
  Close (Q);
End;

begin
end.